/////////////////\\\\\\\\\\\\\\\\
////    vertex_&_filter    \\\\
/////////   Fillellin   \\\\\\\\\
/////////////////\\\\\\\\\\\\\\\\


#property indicator_chart_window


//|

extern string         = " ";
extern int       LlimitHistory           =  1000;                  //     
extern string        = "  ";
extern bool	     SignalMetod             =  false;                 //  FALSE  Signal Metod 1  /   TRUE  Signal Metod 2
extern string       = "";
extern bool	     TRUE__FALSE             =  true;                  //  TRUE  SignalMetod  /   FALSE  SignalFilter
extern string      = "";
extern bool	     SignalFilter            =  false;                 //  FALSE  Signal Filter 1  /   TRUE  Signal Filter 2
extern string  = "  vertex";
extern string    TimeFrame_vertex        =  "Current time frame";  //     "vertex"
extern int       Processed_vertex        =  2000;
extern int       Control_Period_vertex   =  14;
extern int       UpperLevel_vertex       =  6;                     //     "vertex"
extern int       LowerLevel_vertex       = -6;                     //     "vertex"
extern string   = "  filter";
extern string    TimeFrame_filter        =  "Current time frame";  //     "filter"
extern int       Processed_filter        =  2000;
extern int       Control_Period_filter   =  14;
extern int       UpperLevel_filter       =  6;                     //     "filter"
extern int       LowerLevel_filter       = -6;                     //     "filter"
extern string    = "   ";
extern bool	     ShowAlert               =  true;                  //   "Alert" ?
extern bool      SendPush                =  false;                 //  PUSH    ?
extern bool      SendMailInfo            =  false;                 //      ?
extern bool      ShowSound               =  false;                 //    "Sound" ?
extern string    SoundNameBuy            =  "buy.wav";             //    "Buy"
extern string    SoundNameSell           =  "sell.wav";            //    "Sell"
extern string     = "      ";
extern bool      DrawAgainSignals        =  false;                 //       ?
extern color     ColorArrBULL            =  clrLime;               //    "Buy"
extern color     ColorTxtBULL            =  clrLightSlateGray;     //    "Buy"
extern color     ColorArrBEAR            =  clrOrangeRed;          //    "Sell"
extern color     ColorTxtBEAR            =  clrLightSlateGray;     //    "Sell"
extern int       IndentArrow             =  3;                     //    High  /  Low 
extern bool	     ShowInfoText            =  true;                  //     ?
extern string    TextForUp               =  "BULL";                //   "Buy"
extern string    TextForDown             =  "BEAR";                //   "Sell"
extern int       TextSize                =  8;                     //  

//|

int    flagsUP = 0;
int    flagsPU = 0;
int    flagsDN = 0;
int    flagsND = 0;

double middleArrUP;
double shiftArrUP;
double middleTxtUP;
double shiftTxtUP;
double middleArrDN;
double shiftArrDN;
double middleTxtDN;
double shiftTxtDN;

bool   upAlert = false;
bool   dnAlert = false;

//---------------------|

int deinit()
{
   obj_delete( "FLN_" );

   return(0);
}

//----------------------------------------------------------------------------------------------------------------------------------------------|

int start()
{

   double Cust_vertex, Cust_vertez, Cust_filter, Cust_filten;


   for( int i = LlimitHistory;  i >= 0;  i -- )
   {           

      Cust_vertex = iCustom( NULL, 0, "vertex_&_filter", TimeFrame_vertex, Processed_vertex, Control_Period_vertex, 0, 0, 0, 0, 0, 0, 0, i     );
      Cust_vertez = iCustom( NULL, 0, "vertex_&_filter", TimeFrame_vertex, Processed_vertex, Control_Period_vertex, 0, 0, 0, 0, 0, 0, 0, i + 1 );

      Cust_filter = iCustom( NULL, 0, "vertex_&_filter", TimeFrame_filter, Processed_filter, Control_Period_filter, 0, 0, 0, 0, 0, 0, 0, i     );
      Cust_filten = iCustom( NULL, 0, "vertex_&_filter", TimeFrame_filter, Processed_filter, Control_Period_filter, 0, 0, 0, 0, 0, 0, 0, i + 1 );


//--------------------------------------------------------------------------------|


      long   height  =   ChartGetInteger( 0, CHART_HEIGHT_IN_PIXELS, 0 );
      double indent  =   IndentArrow * Point;

      middleArrUP    = ( WindowPriceMax() - WindowPriceMin() ) / ( height /  8.0 );
      shiftArrUP     =   Low[i]         - ( middleArrUP      +     indent );
      middleTxtUP    = ( WindowPriceMax() - WindowPriceMin() ) / ( height / 15.0 );
      shiftTxtUP     =   shiftArrUP       - middleTxtUP;

      middleArrDN    = ( WindowPriceMax() - WindowPriceMin() ) / ( height / 20.0 );
      shiftArrDN     =   High[i]        + ( middleArrDN      +     indent );
      middleTxtDN    = ( WindowPriceMax() - WindowPriceMin() ) / ( height / 15.9 );
      shiftTxtDN     =   shiftArrDN       + middleTxtDN;

      datetime time  =   iTime( Symbol(), Period(), i );
      string   date  =   TimeToStr( time, TIME_DATE | TIME_MINUTES );


//--- Start SignalMetod -----------------------------------------------------------------------------------------------------|


      if( TRUE__FALSE )
      {
         if( !SignalMetod )
         {
            if( Cust_vertex <= LowerLevel_vertex && flagsUP == 0 )
            {
               ArrFln( StringConcatenate( "ArrUP ", date ), 233, Time[i], shiftArrUP, ColorArrBULL );

               if( ShowInfoText ) TxtFln( StringConcatenate( "TxtUP ", date ), TextForUp, Time[i], shiftTxtUP, ColorTxtBULL );

               flagsUP = 1;
               flagsPU = 0;
            }

            if( Cust_vertex > LowerLevel_vertex && flagsPU == 0 )
            {
               flagsPU = 1;
               flagsUP = 0;
            }

//-------|

            if( Cust_vertex >= UpperLevel_vertex && flagsDN == 0 )
            {
               ArrFln( StringConcatenate( "ArrDN ", date ), 234, Time[i], shiftArrDN, ColorArrBEAR );

               if( ShowInfoText ) TxtFln( StringConcatenate( "TxtDN ", date ), TextForDown, Time[i], shiftTxtDN, ColorTxtBEAR );

               flagsDN = 1;
               flagsND = 0;
            }

            if( Cust_vertex < UpperLevel_vertex && flagsND == 0 )
            {
               flagsND = 1;
               flagsDN = 0;
            }

//----|

         }
         else
         {

//----|

            if( Cust_vertez <= LowerLevel_vertex && Cust_vertex > Cust_vertez && flagsUP == 0 )
            {
               ArrFln( StringConcatenate( "ArrUP ", date ), 233, Time[i], shiftArrUP, ColorArrBULL );

               if( ShowInfoText ) TxtFln( StringConcatenate( "TxtUP ", date ), TextForUp, Time[i], shiftTxtUP, ColorTxtBULL );

               flagsUP = 1;
               flagsPU = 0;
            }

            if( Cust_vertex > LowerLevel_vertex && flagsPU == 0 )
            {
               flagsPU = 1;
               flagsUP = 0;
            }

//-------|

            if( Cust_vertez >= UpperLevel_vertex && Cust_vertex < Cust_vertez && flagsDN == 0 )
            {
               ArrFln( StringConcatenate( "ArrDN ", date ), 234, Time[i], shiftArrDN, ColorArrBEAR );

               if( ShowInfoText ) TxtFln( StringConcatenate( "TxtDN ", date ), TextForDown, Time[i], shiftTxtDN, ColorTxtBEAR );

               flagsDN = 1;
               flagsND = 0;
            }

            if( Cust_vertex < UpperLevel_vertex && flagsND == 0 )
            {
               flagsND = 1;
               flagsDN = 0;
            }
         }


//--- End SignalMetod -------------------------------------------------------------------------------------------------------|


      }
      else
      {


//--- Start SignalFilter ----------------------------------------------------------------------------------------------------|


         if( !SignalFilter )
         {
            if( Cust_vertex <= LowerLevel_vertex && Cust_filter <= LowerLevel_vertex && flagsUP == 0 )
            {
               ArrFln( StringConcatenate( "ArrUP ", date ), 233, Time[i], shiftArrUP, ColorArrBULL );

               if( ShowInfoText ) TxtFln( StringConcatenate( "TxtUP ", date ), TextForUp, Time[i], shiftTxtUP, ColorTxtBULL );

               flagsUP = 1;
               flagsPU = 0;
            }

            if( Cust_vertex > LowerLevel_vertex && flagsPU == 0 )
            {
               flagsPU = 1;
               flagsUP = 0;
            }

//-------|

            if( Cust_vertex >= UpperLevel_vertex && Cust_filter >= UpperLevel_vertex && flagsDN == 0 )
            {
               ArrFln( StringConcatenate( "ArrDN ", date ), 234, Time[i], shiftArrDN, ColorArrBEAR );

               if( ShowInfoText ) TxtFln( StringConcatenate( "TxtDN ", date ), TextForDown, Time[i], shiftTxtDN, ColorTxtBEAR );

               flagsDN = 1;
               flagsND = 0;
            }

            if( Cust_vertex < UpperLevel_vertex && flagsND == 0 )
            {
               flagsND = 1;
               flagsDN = 0;
            }

//----|

         }
         else
         {

//----|

            if( Cust_vertex <= LowerLevel_vertex && Cust_vertex > Cust_vertez && Cust_filter <= LowerLevel_vertex && flagsUP == 0 )
            {
               ArrFln( StringConcatenate( "ArrUP ", date ), 233, Time[i], shiftArrUP, ColorArrBULL );

               if( ShowInfoText ) TxtFln( StringConcatenate( "TxtUP ", date ), TextForUp, Time[i], shiftTxtUP, ColorTxtBULL );

               flagsUP = 1;
               flagsPU = 0;
            }

            if( Cust_vertex > LowerLevel_vertex && flagsPU == 0 )
            {
               flagsPU = 1;
               flagsUP = 0;
            }

//-------|

            if( Cust_vertez >= UpperLevel_vertex && Cust_vertex < Cust_vertez && Cust_filter >= UpperLevel_vertex && flagsDN == 0 )
            {
               ArrFln( StringConcatenate( "ArrDN ", date ), 234, Time[i], shiftArrDN, ColorArrBEAR );

               if( ShowInfoText ) TxtFln( StringConcatenate( "TxtDN ", date ), TextForDown, Time[i], shiftTxtDN, ColorTxtBEAR );

               flagsDN = 1;
               flagsND = 0;
            }

            if( Cust_vertex < UpperLevel_vertex && flagsND == 0 )
            {
               flagsND = 1;
               flagsDN = 0;
            }
         }
      }
   }


//--- End SignalFilter -----------------------------------------------------------------------------------------------------------|


//--- Block signals ----------------------------------------------------------------------------------------------------------------------------------------------|


   if ( flagsUP == 1 && upAlert )
   {
      upAlert = false;

      if ( SendPush     ) SendNotification( StringConcatenate( " vertex_&_filter  /  " + Symbol(), "   ", periods(), "   ( ", TextForUp, " = ", Bid, " )" ));

      if ( SendMailInfo ) SendMail( StringConcatenate( " vertex_&_filter  /  ", AccountCompany(), " ", AccountNumber(), " ", Symbol() ),
                          StringConcatenate( "   ", periods(), "   ( ", TextForUp, " = ", Bid, " )", " ", TimeToStr( TimeCurrent(), TIME_DATE | TIME_MINUTES )));

      if ( ShowAlert    ) Alert( " vertex_&_filter  /  ", Symbol(), "   ", periods(), "   ( ", TextForUp, " = ", Bid, " )" );

      if ( ShowSound    ) PlaySound ( SoundNameBuy );
   }

   if ( !upAlert && flagsUP != 1 ) upAlert = true;


//-----------------------------------------------|


   if ( flagsDN == 1 && dnAlert )
   {
      dnAlert = false;

      if ( SendPush     ) SendNotification( StringConcatenate( " vertex_&_filter  /  ", Symbol(), "   ", periods(), "   ( ", TextForDown, " = ", Bid, " )" ));

      if ( SendMailInfo ) SendMail( StringConcatenate( " vertex_&_filter  /  ", AccountCompany(), " ", AccountNumber(), " ", Symbol() ),
                          StringConcatenate( "   ", periods(), "   ( ", TextForDown, " = ", Bid, " )", " ", TimeToStr( TimeCurrent(), TIME_DATE | TIME_MINUTES )));

      if ( ShowAlert    ) Alert( " vertex_&_filter  /  ", Symbol(), "   ", periods(), "   ( ", TextForDown, " = ", Bid, " )" );

      if ( ShowSound    ) PlaySound ( SoundNameSell );
   }

   if ( !dnAlert && flagsDN != 1 ) dnAlert = true;


//------------------------------------------------------------------------------------------------------------------------------------------------------------------|


  return (0);
}

//--------------------------------|

string periods()
{
   switch( Period() )
   {
      case 1     : return( "M1"  );
      case 5     : return( "M5"  );
      case 15    : return( "M15" );
      case 30    : return( "M30" );
      case 60    : return( "H1"  );
      case 240   : return( "H4"  );
      case 1440  : return( "D1"  );
      case 10080 : return( "W1"  );
      case 43200 : return( "MN"  );

      default: return( "default" );
   }
}

//------------------------------------------------------------------------------|

void TxtFln( string main, string text, datetime time, double price, color colir )
{
   string name = StringConcatenate( "FLN_", main );

   if( ObjectFind( name ) != -1 )  ObjectDelete( name );

   ObjectCreate   ( name, OBJ_TEXT, 0, time, price );
   ObjectSetText  ( name, text, TextSize, "Times New Roman", colir );
   ObjectSet      ( name, OBJPROP_BACK, false );
}

//---------------------------------------------------------------------------|

void ArrFln( string main, int code, datetime time, double price, color Color )
{
   string name = StringConcatenate( "FLN_", main );

   if( ObjectFind( name ) != -1 )  ObjectDelete( name );
   {
      ObjectCreate( name, OBJ_ARROW, 0, time, price );
      ObjectSet   ( name, OBJPROP_ARROWCODE,   code );
      ObjectSet   ( name, OBJPROP_COLOR,      Color );
      ObjectSet   ( name, OBJPROP_WIDTH,          0 );
      ObjectSet   ( name, OBJPROP_BACK,       false );
   }
}

//--------------------------------------------------------------|

void obj_delete( string prefix )
{
   int obj_total = ObjectsTotal();  string name;

   for( int i = obj_total - 1; i >= 0; i -- )
   {
      name = ObjectName(i);

      if( StringFind( name, prefix ) == 0 ) ObjectDelete( name );
   }
}

//| end of the algorithm ||